/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_RESTRICTED = 258,
     TOK_GENERAL = 259,
     TOK_ABSOLUTE = 260,
     TOK_AT = 261,
     TOK_COMPONENT = 262,
     TOK_DECLARE = 263,
     TOK_DEFINE = 264,
     TOK_DEFINITION = 265,
     TOK_END = 266,
     TOK_FINALLY = 267,
     TOK_EXTERN = 268,
     TOK_INITIALIZE = 269,
     TOK_INSTRUMENT = 270,
     TOK_MCDISPLAY = 271,
     TOK_OUTPUT = 272,
     TOK_PARAMETERS = 273,
     TOK_POLARISATION = 274,
     TOK_RELATIVE = 275,
     TOK_ROTATED = 276,
     TOK_PREVIOUS = 277,
     TOK_SETTING = 278,
     TOK_STATE = 279,
     TOK_TRACE = 280,
     TOK_SHARE = 281,
     TOK_EXTEND = 282,
     TOK_GROUP = 283,
     TOK_SAVE = 284,
     TOK_NEXUS = 285,
     TOK_DICTFILE = 286,
     TOK_HDF = 287,
     TOK_JUMP = 288,
     TOK_WHEN = 289,
     TOK_NEXT = 290,
     TOK_ITERATE = 291,
     TOK_MYSELF = 292,
     TOK_COPY = 293,
     TOK_ID = 294,
     TOK_STRING = 295,
     TOK_NUMBER = 296,
     TOK_CTOK = 297,
     TOK_CODE_START = 298,
     TOK_CODE_END = 299,
     TOK_CODE_LINE = 300,
     TOK_INVALID = 301
   };
#endif
#define TOK_RESTRICTED 258
#define TOK_GENERAL 259
#define TOK_ABSOLUTE 260
#define TOK_AT 261
#define TOK_COMPONENT 262
#define TOK_DECLARE 263
#define TOK_DEFINE 264
#define TOK_DEFINITION 265
#define TOK_END 266
#define TOK_FINALLY 267
#define TOK_EXTERN 268
#define TOK_INITIALIZE 269
#define TOK_INSTRUMENT 270
#define TOK_MCDISPLAY 271
#define TOK_OUTPUT 272
#define TOK_PARAMETERS 273
#define TOK_POLARISATION 274
#define TOK_RELATIVE 275
#define TOK_ROTATED 276
#define TOK_PREVIOUS 277
#define TOK_SETTING 278
#define TOK_STATE 279
#define TOK_TRACE 280
#define TOK_SHARE 281
#define TOK_EXTEND 282
#define TOK_GROUP 283
#define TOK_SAVE 284
#define TOK_NEXUS 285
#define TOK_DICTFILE 286
#define TOK_HDF 287
#define TOK_JUMP 288
#define TOK_WHEN 289
#define TOK_NEXT 290
#define TOK_ITERATE 291
#define TOK_MYSELF 292
#define TOK_COPY 293
#define TOK_ID 294
#define TOK_STRING 295
#define TOK_NUMBER 296
#define TOK_CTOK 297
#define TOK_CODE_START 298
#define TOK_CODE_END 299
#define TOK_CODE_LINE 300
#define TOK_INVALID 301




/* Copy the first part of user declarations.  */
#line 24 "instrument.y"

#include <math.h>
#include <string.h>
#include <stdio.h>

#include "mcstas.h"

#define YYERROR_VERBOSE 1
#define YYDEBUG 1



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 44 "instrument.y"
typedef union YYSTYPE {
  char *number;
  char *string;
  struct code_block *ccode; /* User-supplied C code block */
  CExp exp;     /* Expression datatype (for arguments) */
  int linenum;      /* Starting line number for code block */
  Coords_exp coords;    /* Coordinates for location or rotation */
  List formals;     /* List of formal parameters */
  List iformals;    /* List of formal instrument parameters */
  List comp_iformals;   /* List of formal comp. input parameters */
  struct instr_formal *iformal; /* Single formal instrument parameter */
  struct comp_iformal *cformal; /* Single formal component input parameter */
  Symtab actuals;   /* Values for formal parameters */
  char **polform;   /* Polarisation state formal parameter */
  struct {List def, set, out, state;
    char **polarisation;} parms;  /* Parameter lists */
  struct instr_def *instrument; /* Instrument definition */
  struct comp_inst *instance; /* Component instance */
  struct comp_place place;  /* Component place */
  struct comp_orientation ori;  /* Component orientation */
  struct NXDinfo *nxdinfo;  /* Info for NeXus dictionary interface */
  struct group_inst *groupinst;
  struct jump_struct *jump;
  List   jumps;
  struct jump_condition jumpcondition;
  struct jump_name      jumpname;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 208 "instrument.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 220 "instrument.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  7
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   322

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  56
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  64
/* YYNRULES -- Number of rules. */
#define YYNRULES  150
/* YYNRULES -- Number of states. */
#define YYNSTATES  278

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   301

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      47,    49,    50,     2,    48,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    51,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    52,     2,    53,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    54,     2,    55,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     7,    10,    11,    14,    27,    42,    48,
      49,    53,    54,    58,    59,    63,    64,    68,    69,    79,
      83,    84,    86,    88,    92,    95,    99,   101,   105,   110,
     116,   117,   130,   134,   135,   137,   139,   143,   146,   150,
     152,   156,   161,   167,   168,   173,   174,   178,   179,   183,
     184,   187,   191,   197,   198,   202,   208,   211,   212,   215,
     219,   225,   226,   229,   233,   239,   240,   243,   247,   253,
     254,   257,   261,   267,   268,   271,   275,   281,   284,   285,
     288,   293,   295,   301,   306,   309,   320,   324,   325,   327,
     329,   333,   337,   338,   340,   344,   350,   351,   354,   358,
     359,   363,   365,   368,   371,   372,   375,   377,   379,   384,
     386,   394,   395,   398,   399,   401,   403,   406,   410,   413,
     416,   418,   423,   425,   427,   432,   434,   435,   438,   439,
     443,   445,   448,   450,   452,   454,   456,   458,   460,   464,
     467,   471,   474,   478,   481,   483,   486,   488,   490,   494,
     495
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      57,     0,    -1,     4,    58,    70,    -1,     3,    59,    -1,
      -1,    58,    59,    -1,     9,     7,    39,    60,    81,    79,
      80,    82,    83,    84,    85,    11,    -1,     9,     7,    39,
      38,    39,    60,    81,    79,    80,    82,    83,    84,    85,
      11,    -1,    61,    62,    63,    64,    65,    -1,    -1,    10,
      18,    66,    -1,    -1,    23,    18,    66,    -1,    -1,    17,
      18,    91,    -1,    -1,    24,    18,    91,    -1,    -1,    19,
      18,    47,    39,    48,    39,    48,    39,    49,    -1,    47,
      67,    49,    -1,    -1,    68,    -1,    69,    -1,    68,    48,
      69,    -1,    39,    39,    -1,    39,    50,    39,    -1,    39,
      -1,    39,    51,   111,    -1,    39,    39,    51,   111,    -1,
      39,    50,    39,    51,   111,    -1,    -1,     9,    15,    39,
      72,    71,    79,    80,    76,    86,    83,    84,    11,    -1,
      47,    73,    49,    -1,    -1,    74,    -1,    75,    -1,    74,
      48,    75,    -1,    39,    39,    -1,    39,    50,    39,    -1,
      39,    -1,    39,    51,   111,    -1,    39,    39,    51,   111,
      -1,    39,    50,    39,    51,   111,    -1,    -1,    76,    30,
      77,    78,    -1,    -1,    77,    31,    40,    -1,    -1,    78,
      32,    41,    -1,    -1,     8,   118,    -1,     8,    38,    39,
      -1,     8,    38,    39,    27,   118,    -1,    -1,    14,    38,
      39,    -1,    14,    38,    39,    27,   118,    -1,    14,   118,
      -1,    -1,    26,   118,    -1,    26,    38,    39,    -1,    26,
      38,    39,    27,   118,    -1,    -1,    25,   118,    -1,    25,
      38,    39,    -1,    25,    38,    39,    27,   118,    -1,    -1,
      29,   118,    -1,    29,    38,    39,    -1,    29,    38,    39,
      27,   118,    -1,    -1,    12,   118,    -1,    12,    38,    39,
      -1,    12,    38,    39,    27,   118,    -1,    -1,    16,   118,
      -1,    16,    38,    39,    -1,    16,    38,    39,    27,   118,
      -1,    25,    87,    -1,    -1,    87,    90,    -1,    38,    47,
      39,    49,    -1,    39,    -1,    38,    47,   103,    49,    94,
      -1,    38,    47,   103,    49,    -1,    39,    94,    -1,     7,
      88,    51,    89,    97,    98,    99,   101,   105,   106,    -1,
      47,    92,    49,    -1,    -1,    93,    -1,    39,    -1,    93,
      48,    39,    -1,    47,    95,    49,    -1,    -1,    96,    -1,
      39,    51,   111,    -1,    96,    48,    39,    51,   111,    -1,
      -1,    34,   111,    -1,     6,   104,   100,    -1,    -1,    21,
     104,   100,    -1,     5,    -1,    20,     5,    -1,    20,   103,
      -1,    -1,    28,   102,    -1,    39,    -1,    22,    -1,    22,
      47,    41,    49,    -1,    39,    -1,    47,   111,    48,   111,
      48,   111,    49,    -1,    -1,    27,   118,    -1,    -1,   107,
      -1,   108,    -1,   107,   108,    -1,    33,   110,   109,    -1,
      34,   111,    -1,    36,   111,    -1,    22,    -1,    22,    47,
      41,    49,    -1,    37,    -1,    35,    -1,    35,    47,    41,
      49,    -1,    39,    -1,    -1,   112,   114,    -1,    -1,    13,
     113,    39,    -1,   115,    -1,   114,   115,    -1,    39,    -1,
      41,    -1,    40,    -1,    42,    -1,    51,    -1,    50,    -1,
      47,   116,    49,    -1,    47,    49,    -1,    52,   116,    53,
      -1,    52,    53,    -1,    54,   116,    55,    -1,    54,    55,
      -1,   117,    -1,   116,   117,    -1,   115,    -1,    48,    -1,
      43,   119,    44,    -1,    -1,   119,    45,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   146,   146,   147,   150,   151,   154,   184,   228,   240,
     243,   250,   253,   260,   263,   270,   273,   280,   283,   294,
     301,   304,   310,   315,   322,   340,   354,   363,   373,   393,
     412,   411,   434,   441,   444,   450,   455,   462,   480,   494,
     503,   513,   533,   553,   560,   579,   582,   588,   591,   599,
     602,   606,   612,   628,   631,   637,   650,   658,   661,   665,
     671,   689,   692,   696,   702,   718,   721,   725,   731,   747,
     750,   754,   760,   776,   779,   783,   789,   804,   807,   813,
     841,   847,   853,   872,   889,   913,   944,   952,   955,   961,
     966,   973,   980,   983,   989,   995,  1004,  1007,  1013,  1021,
    1025,  1034,  1038,  1042,  1050,  1053,  1059,  1079,  1088,  1102,
    1119,  1129,  1132,  1139,  1142,  1148,  1153,  1160,  1172,  1177,
    1184,  1189,  1194,  1199,  1204,  1208,  1217,  1217,  1223,  1223,
    1234,  1238,  1248,  1271,  1276,  1281,  1286,  1290,  1294,  1303,
    1311,  1320,  1328,  1337,  1348,  1352,  1360,  1364,  1370,  1380,
    1384
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_RESTRICTED", "TOK_GENERAL",
  "\"ABSOLUTE\"", "\"AT\"", "\"COMPONENT\"", "\"DECLARE\"", "\"DEFINE\"",
  "\"DEFINITION\"", "\"END\"", "\"FINALLY\"", "\"EXTERN\"",
  "\"INITIALIZE\"", "\"INSTRUMENT\"", "\"MCDISPLAY\"", "\"OUTPUT\"",
  "\"PARAMETERS\"", "\"POLARISATION\"", "\"RELATIVE\"", "\"ROTATED\"",
  "\"PREVIOUS\"", "\"SETTING\"", "\"STATE\"", "\"TRACE\"", "\"SHARE\"",
  "\"EXTEND\"", "\"GROUP\"", "\"SAVE\"", "\"NEXUS\"", "\"DICTFILE\"",
  "\"HDF\"", "\"JUMP\"", "\"WHEN\"", "\"NEXT\"", "\"ITERATE\"",
  "\"MYSELF\"", "\"COPY\"", "TOK_ID", "TOK_STRING", "TOK_NUMBER",
  "TOK_CTOK", "TOK_CODE_START", "TOK_CODE_END", "TOK_CODE_LINE",
  "TOK_INVALID", "'('", "','", "')'", "'*'", "'='", "'['", "']'", "'{'",
  "'}'", "$accept", "main", "compdefs", "compdef", "parameters", "def_par",
  "set_par", "out_par", "state_par", "polarisation_par",
  "comp_iformallist", "comp_iformals", "comp_iformals1", "comp_iformal",
  "instrument", "@1", "instrpar_list", "instr_formals", "instr_formals1",
  "instr_formal", "nexus", "dictfile", "hdfversion", "declare",
  "initialize", "share", "trace", "save", "finally", "mcdisplay",
  "instr_trace", "complist", "instname", "instref", "component",
  "formallist", "formals", "formals1", "actuallist", "actuals", "actuals1",
  "when", "place", "orientation", "reference", "groupref", "groupdef",
  "compref", "coords", "extend", "jumps", "jumps1", "jump",
  "jumpcondition", "jumpname", "exp", "@2", "@3", "topexp", "topatexp",
  "genexp", "genatexp", "codeblock", "code", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    40,    44,    41,
      42,    61,    91,    93,   123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    56,    57,    57,    58,    58,    59,    59,    60,    61,
      61,    62,    62,    63,    63,    64,    64,    65,    65,    66,
      67,    67,    68,    68,    69,    69,    69,    69,    69,    69,
      71,    70,    72,    73,    73,    74,    74,    75,    75,    75,
      75,    75,    75,    76,    76,    77,    77,    78,    78,    79,
      79,    79,    79,    80,    80,    80,    80,    81,    81,    81,
      81,    82,    82,    82,    82,    83,    83,    83,    83,    84,
      84,    84,    84,    85,    85,    85,    85,    86,    87,    87,
      88,    88,    89,    89,    89,    90,    91,    92,    92,    93,
      93,    94,    95,    95,    96,    96,    97,    97,    98,    99,
      99,   100,   100,   100,   101,   101,   102,   103,   103,   103,
     104,   105,   105,   106,   106,   107,   107,   108,   109,   109,
     110,   110,   110,   110,   110,   110,   112,   111,   113,   111,
     114,   114,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   116,   116,   117,   117,   118,   119,
     119
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     3,     2,     0,     2,    12,    14,     5,     0,
       3,     0,     3,     0,     3,     0,     3,     0,     9,     3,
       0,     1,     1,     3,     2,     3,     1,     3,     4,     5,
       0,    12,     3,     0,     1,     1,     3,     2,     3,     1,
       3,     4,     5,     0,     4,     0,     3,     0,     3,     0,
       2,     3,     5,     0,     3,     5,     2,     0,     2,     3,
       5,     0,     2,     3,     5,     0,     2,     3,     5,     0,
       2,     3,     5,     0,     2,     3,     5,     2,     0,     2,
       4,     1,     5,     4,     2,    10,     3,     0,     1,     1,
       3,     3,     0,     1,     3,     5,     0,     2,     3,     0,
       3,     1,     2,     2,     0,     2,     1,     1,     4,     1,
       7,     0,     2,     0,     1,     1,     2,     3,     2,     2,
       1,     4,     1,     1,     4,     1,     0,     2,     0,     3,
       1,     2,     1,     1,     1,     1,     1,     1,     3,     2,
       3,     2,     3,     2,     1,     2,     1,     1,     3,     0,
       2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     4,     0,     0,     3,     0,     1,     0,     0,
       5,     2,     9,     0,     0,     0,    57,    11,     0,     0,
       9,     0,    49,     0,    13,    33,    30,    20,    10,    57,
       0,   149,    58,     0,    53,     0,     0,    15,    39,     0,
      34,    35,    49,    26,     0,    21,    22,    49,    59,     0,
       0,    50,     0,    61,    12,     0,     0,    17,    37,     0,
     126,    32,     0,    53,    24,     0,   126,    19,     0,    53,
       0,   148,   150,    51,     0,    56,     0,    65,    87,    14,
       0,     0,     8,   126,    38,   128,    40,     0,    36,    43,
     126,    25,    27,    23,    61,    60,     0,    54,     0,    62,
       0,    69,    89,     0,    88,    16,     0,    41,   126,     0,
     132,   134,   133,   135,     0,   137,   136,     0,     0,   127,
     130,     0,    28,   126,    65,    52,     0,    63,     0,    66,
       0,    73,    86,     0,     0,    42,   129,   147,   139,   146,
       0,   144,   141,     0,   143,     0,   131,    78,    45,    65,
      29,    69,    55,     0,    67,     0,    70,     0,     0,    90,
       0,   138,   145,   140,   142,    77,    47,    69,    73,    64,
       0,    71,     0,    74,     6,     0,     0,    79,     0,    44,
       0,     0,    68,     0,    75,     0,     0,    81,     0,    46,
       0,    31,     7,    72,     0,     0,     0,     0,    48,    76,
       0,     0,     0,     0,    96,    18,    80,     0,    92,    84,
     126,     0,   107,   109,     0,     0,     0,    93,    97,     0,
      99,     0,    83,   126,    91,     0,   126,     0,     0,   104,
       0,    82,    94,     0,     0,   101,     0,    98,     0,     0,
     111,   108,   126,   126,   102,   103,   100,   106,   105,     0,
     113,    95,     0,   112,     0,    85,   114,   115,   126,   120,
     123,   122,   125,     0,   116,     0,     0,     0,   126,   126,
     117,   110,     0,     0,   118,   119,   121,   124
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     3,     6,     5,    16,    17,    24,    37,    57,    82,
      28,    44,    45,    46,    11,    42,    26,    39,    40,    41,
     121,   166,   179,    34,    53,    22,    77,   101,   131,   158,
     149,   165,   188,   204,   177,    79,   103,   104,   209,   216,
     217,   211,   220,   229,   237,   240,   248,   214,   227,   250,
     255,   256,   257,   270,   263,    86,    87,   109,   119,   139,
     140,   141,    32,    49
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -146
static const short int yypact[] =
{
      10,     7,  -146,    33,    41,  -146,    43,  -146,     3,    50,
    -146,  -146,    -6,    19,    54,    49,    66,    89,    71,    72,
     111,    -7,   126,   118,   131,    96,  -146,   113,  -146,    66,
     114,  -146,  -146,    23,   140,    72,   137,   138,   -22,   123,
     129,  -146,   126,     5,   133,   130,  -146,   126,   139,    30,
     144,  -146,    35,   162,  -146,   142,   172,   173,   143,   152,
     180,  -146,    96,   140,   145,   158,   180,  -146,   113,   140,
     155,  -146,  -146,   174,   160,  -146,    44,   171,   163,  -146,
     142,   185,  -146,   180,   153,  -146,  -146,   134,  -146,  -146,
     180,   156,  -146,  -146,   162,  -146,   155,   181,   170,  -146,
      47,   198,  -146,   164,   166,  -146,   165,  -146,   180,   176,
    -146,  -146,  -146,  -146,    59,  -146,  -146,    75,    -1,   134,
    -146,    61,  -146,   180,   171,  -146,   155,   184,   178,  -146,
      51,   202,  -146,   182,   183,  -146,  -146,  -146,  -146,  -146,
      91,  -146,  -146,   117,  -146,    29,  -146,  -146,  -146,   171,
    -146,   198,  -146,   155,   192,   186,  -146,   106,   209,  -146,
     175,  -146,  -146,  -146,  -146,   217,   195,   198,   202,  -146,
     155,   200,   189,  -146,  -146,   190,    57,  -146,   191,   201,
     219,   221,  -146,   155,   207,   187,   193,  -146,   188,  -146,
     196,  -146,  -146,  -146,   155,   197,   199,    64,  -146,  -146,
     194,   203,   204,   206,   208,  -146,  -146,   -15,   205,  -146,
     180,   235,   210,  -146,   211,   212,   213,   216,  -146,   214,
     224,   215,   206,   180,  -146,   220,   180,     6,   214,   218,
     222,  -146,  -146,   223,   225,  -146,    -4,  -146,     6,   226,
     227,  -146,   180,   180,  -146,  -146,  -146,  -146,  -146,   155,
     233,  -146,   228,  -146,   -14,  -146,   233,  -146,   180,   230,
     231,  -146,  -146,   -24,  -146,   232,   229,   234,   180,   180,
    -146,  -146,   236,   237,  -146,  -146,  -146,  -146
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -146,  -146,  -146,   241,   238,  -146,  -146,  -146,  -146,  -146,
     244,  -146,  -146,   239,  -146,  -146,  -146,  -146,  -146,   240,
    -146,  -146,  -146,   104,   -54,   243,   154,  -119,  -145,    81,
    -146,  -146,  -146,  -146,  -146,   242,  -146,  -146,    28,  -146,
    -146,  -146,  -146,  -146,    17,  -146,  -146,    31,    40,  -146,
    -146,  -146,    13,  -146,  -146,   -63,  -146,  -146,  -146,   -85,
     -13,   -81,   -33,  -146
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned short int yytable[] =
{
      51,   244,   120,    92,    14,   151,   168,   212,   259,    89,
     268,   235,   269,     1,     2,    94,     4,    58,   212,    75,
     107,   260,   180,   261,   213,   262,   236,   122,    59,    60,
     167,    30,    15,     7,   146,   213,    31,    95,   110,   111,
     112,   113,    12,    99,    64,   135,   114,   137,     8,   115,
     116,   117,     9,   118,   144,    65,    66,     8,    18,   162,
     150,    50,   162,   125,   162,    13,    31,   129,   110,   111,
     112,   113,    19,    74,    71,    72,   114,   137,    31,   115,
     116,   117,    98,   118,   164,   128,   147,    31,    20,   155,
      31,   148,    21,   152,    31,   186,   187,   156,   110,   111,
     112,   113,   202,   203,   143,   145,   114,   137,   138,   115,
     116,   117,    23,   118,   110,   111,   112,   113,    25,    27,
     169,    14,   114,   137,   173,   115,   116,   117,   142,   118,
     110,   111,   112,   113,    33,    38,    35,   182,   114,   137,
     161,   115,   116,   117,   172,   118,    63,   218,    36,    31,
     193,    69,    43,    48,    52,    55,   110,   111,   112,   113,
     232,   199,    56,   234,   114,   137,    70,   115,   116,   117,
     163,   118,    61,   110,   111,   112,   113,    62,    68,   251,
     252,   114,    67,    73,   115,   116,   117,    76,   118,    78,
      80,    84,    81,    85,    83,   265,    90,    91,    31,    97,
     100,    96,   102,   106,   108,   274,   275,   123,   126,   127,
     130,   153,   134,   132,   133,   136,   253,   154,   157,   170,
     174,   159,   160,   175,   176,   171,   178,   183,   184,   185,
     191,   189,   192,   190,   194,   195,   200,   198,   201,   197,
     196,   219,   210,   205,   215,   228,   239,    10,   124,   181,
     231,   207,   206,   208,   249,   246,   230,   221,    29,   233,
     222,   226,   224,   223,   225,   247,   254,   245,   238,   264,
     272,   241,    47,   243,   242,   273,   258,   266,   267,    54,
       0,   271,     0,     0,     0,   276,   277,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    88,     0,     0,     0,     0,    93,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   105
};

static const short int yycheck[] =
{
      33,     5,    87,    66,    10,   124,   151,    22,    22,    63,
      34,     5,    36,     3,     4,    69,     9,    39,    22,    52,
      83,    35,   167,    37,    39,    39,    20,    90,    50,    51,
     149,    38,    38,     0,   119,    39,    43,    70,    39,    40,
      41,    42,    39,    76,    39,   108,    47,    48,     7,    50,
      51,    52,     9,    54,    55,    50,    51,     7,    39,   140,
     123,    38,   143,    96,   145,    15,    43,   100,    39,    40,
      41,    42,    18,    38,    44,    45,    47,    48,    43,    50,
      51,    52,    38,    54,    55,    38,    25,    43,    39,    38,
      43,    30,    26,   126,    43,    38,    39,   130,    39,    40,
      41,    42,    38,    39,   117,   118,    47,    48,    49,    50,
      51,    52,    23,    54,    39,    40,    41,    42,    47,    47,
     153,    10,    47,    48,   157,    50,    51,    52,    53,    54,
      39,    40,    41,    42,     8,    39,    18,   170,    47,    48,
      49,    50,    51,    52,    38,    54,    42,   210,    17,    43,
     183,    47,    39,    39,    14,    18,    39,    40,    41,    42,
     223,   194,    24,   226,    47,    48,    27,    50,    51,    52,
      53,    54,    49,    39,    40,    41,    42,    48,    48,   242,
     243,    47,    49,    39,    50,    51,    52,    25,    54,    47,
      18,    39,    19,    13,    51,   258,    51,    39,    43,    39,
      29,    27,    39,    18,    51,   268,   269,    51,    27,    39,
      12,    27,    47,    49,    48,    39,   249,    39,    16,    27,
      11,    39,    39,    48,     7,    39,    31,    27,    39,    39,
      11,    40,    11,    32,    27,    48,    39,    41,    39,    51,
      47,     6,    34,    49,    39,    21,    28,     6,    94,   168,
     222,    47,    49,    47,    27,   238,    41,    47,    20,    39,
      49,    47,    49,    51,    48,    39,    33,   236,   228,   256,
      41,    49,    29,    48,    51,    41,    48,    47,    47,    35,
      -1,    49,    -1,    -1,    -1,    49,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    80
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     4,    57,     9,    59,    58,     0,     7,     9,
      59,    70,    39,    15,    10,    38,    60,    61,    39,    18,
      39,    26,    81,    23,    62,    47,    72,    47,    66,    60,
      38,    43,   118,     8,    79,    18,    17,    63,    39,    73,
      74,    75,    71,    39,    67,    68,    69,    81,    39,   119,
      38,   118,    14,    80,    66,    18,    24,    64,    39,    50,
      51,    49,    48,    79,    39,    50,    51,    49,    48,    79,
      27,    44,    45,    39,    38,   118,    25,    82,    47,    91,
      18,    19,    65,    51,    39,    13,   111,   112,    75,    80,
      51,    39,   111,    69,    80,   118,    27,    39,    38,   118,
      29,    83,    39,    92,    93,    91,    18,   111,    51,   113,
      39,    40,    41,    42,    47,    50,    51,    52,    54,   114,
     115,    76,   111,    51,    82,   118,    27,    39,    38,   118,
      12,    84,    49,    48,    47,   111,    39,    48,    49,   115,
     116,   117,    53,   116,    55,   116,   115,    25,    30,    86,
     111,    83,   118,    27,    39,    38,   118,    16,    85,    39,
      39,    49,   117,    53,    55,    87,    77,    83,    84,   118,
      27,    39,    38,   118,    11,    48,     7,    90,    31,    78,
      84,    85,   118,    27,    39,    39,    38,    39,    88,    40,
      32,    11,    11,   118,    27,    48,    47,    51,    41,   118,
      39,    39,    38,    39,    89,    49,    49,    47,    47,    94,
      34,    97,    22,    39,   103,    39,    95,    96,   111,     6,
      98,    47,    49,    51,    49,    48,    47,   104,    21,    99,
      41,    94,   111,    39,   111,     5,    20,   100,   104,    28,
     101,    49,    51,    48,     5,   103,   100,    39,   102,    27,
     105,   111,   111,   118,    33,   106,   107,   108,    48,    22,
      35,    37,    39,   110,   108,   111,    47,    47,    34,    36,
     109,    49,    41,    41,   111,   111,    49,    49
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 155 "instrument.y"
    {
        struct comp_def *c;
        palloc(c);
        c->name = yyvsp[-9].string;
        /* ADD: E. Farhi, Aug 14th, 2002 */
        c->source = str_quote(instr_current_filename);
        c->def_par = yyvsp[-8].parms.def;
        c->set_par = yyvsp[-8].parms.set;
        c->out_par = yyvsp[-8].parms.out;
        c->state_par = yyvsp[-8].parms.state;
        c->polarisation_par = yyvsp[-8].parms.polarisation;
        c->share_code = yyvsp[-7].ccode;  /* ADD: E. Farhi Sep 20th, 2001 */
        c->decl_code = yyvsp[-6].ccode;  /* MOD: E. Farhi Sep 20th, 2001, shifted param numbs */
        c->init_code = yyvsp[-5].ccode;
        c->trace_code = yyvsp[-4].ccode;
        c->save_code = yyvsp[-3].ccode;  /* ADD: E. Farhi Aug 25th, 2002+shifted indexes */
        c->finally_code = yyvsp[-2].ccode;
        c->mcdisplay_code = yyvsp[-1].ccode;
        c->comp_inst_number = 0; /* ADD: E. Farhi Sep 20th, 2001 */

        /* Check definition and setting params for uniqueness */
        check_comp_formals(c->def_par, c->set_par, c->name);
        /* Put component definition in table. */
        symtab_add(read_components, c->name, c);
        /* checks */
        if (!list_len(c->state_par)) print_error("No particule state parameters defined in component "
          "%s at line %s:%d.\n", yyvsp[-9].string, instr_current_filename, instr_current_line);
        if (verbose) fprintf(stderr, "Embedding component %s from file %s\n", c->name, c->source);
      ;}
    break;

  case 7:
#line 185 "instrument.y"
    {
        /* create a copy of a comp, and initiate it with given blocks */
        /* all redefined blocks override */
        struct comp_def *def;
        def = read_component(yyvsp[-9].string);
        struct comp_def *c;
        palloc(c);
        c->name = yyvsp[-11].string;
        c->source = str_quote(instr_current_filename);
        /* only catenate if defined as non empty  */
        c->def_par   = list_create(); list_cat(c->def_par, def->def_par);
        if (list_len(yyvsp[-8].parms.def)) list_cat(c->def_par,yyvsp[-8].parms.def);

        c->set_par   = list_create(); list_cat(c->set_par, def->set_par);
        if (list_len(yyvsp[-8].parms.set)) list_cat(c->set_par,yyvsp[-8].parms.set);

        c->out_par   = list_create(); list_cat(c->out_par, def->out_par);
        if (list_len(yyvsp[-8].parms.out)) list_cat(c->out_par,yyvsp[-8].parms.out);

        c->state_par = (list_len(yyvsp[-8].parms.state) ? yyvsp[-8].parms.state : def->state_par);
        c->polarisation_par = (yyvsp[-8].parms.polarisation ? yyvsp[-8].parms.polarisation : def->polarisation_par);

        c->share_code = (yyvsp[-7].ccode->linenum ?  yyvsp[-7].ccode  : def->share_code);
        c->decl_code  = (yyvsp[-6].ccode->linenum ?  yyvsp[-6].ccode  : def->decl_code);
        c->init_code  = (yyvsp[-5].ccode->linenum ?  yyvsp[-5].ccode  : def->init_code);
        c->trace_code = (yyvsp[-4].ccode->linenum ? yyvsp[-4].ccode : def->trace_code);
        c->save_code  = (yyvsp[-3].ccode->linenum ? yyvsp[-3].ccode : def->save_code);
        c->finally_code = (yyvsp[-2].ccode->linenum ? yyvsp[-2].ccode : def->finally_code);
        c->mcdisplay_code = (yyvsp[-1].ccode->linenum ? yyvsp[-1].ccode : def->mcdisplay_code);
        c->comp_inst_number = 0;

        /* Check definition and setting params for uniqueness */
        check_comp_formals(c->def_par, c->set_par, c->name);
        /* Put component definition in table. */
        symtab_add(read_components, c->name, c);
        /* checks */
        if (!list_len(c->state_par)) print_error("No particule state parameters defined in (copied) component "
          "%s at line %s:%d.\n", yyvsp[-11].string, instr_current_filename, instr_current_line);
        if (verbose) fprintf(stderr, "Embedding component %s from file %s\n", c->name, c->source);

      ;}
    break;

  case 8:
#line 229 "instrument.y"
    {
        yyval.parms.def = yyvsp[-4].formals;
        yyval.parms.set = yyvsp[-3].formals;
        yyval.parms.out = yyvsp[-2].formals;
        yyval.parms.state = yyvsp[-1].formals;
        yyval.parms.polarisation = yyvsp[0].polform;
      ;}
    break;

  case 9:
#line 240 "instrument.y"
    {
        yyval.formals = list_create();
      ;}
    break;

  case 10:
#line 244 "instrument.y"
    {
        yyval.formals = yyvsp[0].comp_iformals;
      ;}
    break;

  case 11:
#line 250 "instrument.y"
    {
        yyval.formals = list_create();
      ;}
    break;

  case 12:
#line 254 "instrument.y"
    {
        yyval.formals = yyvsp[0].comp_iformals;
      ;}
    break;

  case 13:
#line 260 "instrument.y"
    {
        yyval.formals = list_create();
      ;}
    break;

  case 14:
#line 264 "instrument.y"
    {
        yyval.formals = yyvsp[0].formals;
      ;}
    break;

  case 15:
#line 270 "instrument.y"
    {
        yyval.formals = list_create();
      ;}
    break;

  case 16:
#line 274 "instrument.y"
    {
        yyval.formals = yyvsp[0].formals;
      ;}
    break;

  case 17:
#line 280 "instrument.y"
    {
        yyval.polform = NULL;
      ;}
    break;

  case 18:
#line 284 "instrument.y"
    {
        char **polform;
        nalloc(polform, 3);
        polform[0] = yyvsp[-5].string;
        polform[1] = yyvsp[-3].string;
        polform[2] = yyvsp[-1].string;
        yyval.polform = polform;
      ;}
    break;

  case 19:
#line 295 "instrument.y"
    {
        yyval.comp_iformals = yyvsp[-1].comp_iformals;
      ;}
    break;

  case 20:
#line 301 "instrument.y"
    {
        yyval.comp_iformals = list_create();
      ;}
    break;

  case 21:
#line 305 "instrument.y"
    {
        yyval.comp_iformals = yyvsp[0].comp_iformals;
      ;}
    break;

  case 22:
#line 311 "instrument.y"
    {
        yyval.comp_iformals = list_create();
        list_add(yyval.comp_iformals, yyvsp[0].cformal);
      ;}
    break;

  case 23:
#line 316 "instrument.y"
    {
        list_add(yyvsp[-2].comp_iformals, yyvsp[0].cformal);
        yyval.comp_iformals = yyvsp[-2].comp_iformals;
      ;}
    break;

  case 24:
#line 323 "instrument.y"
    {
        struct comp_iformal *formal;
        palloc(formal);
        if(!strcmp(yyvsp[-1].string, "double")) {
          formal->type = instr_type_double;
        } else if(!strcmp(yyvsp[-1].string, "int")) {
          formal->type = instr_type_int;
        } else if(!strcmp(yyvsp[-1].string, "string")) {
          formal->type = instr_type_string;
        } else {
          print_error("Illegal type %s for component "
          "parameter %s at line %s:%d.\n", yyvsp[-1].string, yyvsp[0].string, instr_current_filename, instr_current_line);
          formal->type = instr_type_double;
        }
        formal->id = yyvsp[0].string;
        yyval.cformal = formal;
      ;}
    break;

  case 25:
#line 341 "instrument.y"
    {
        struct comp_iformal *formal;
        palloc(formal);
        if(!strcmp(yyvsp[-2].string, "char")) {
          formal->type = instr_type_string;
        } else {
          print_error("Illegal type %s* for component "
          "parameter %s at line $s:%d.\n", yyvsp[-2].string, yyvsp[0].string, instr_current_filename, instr_current_line);
          formal->type = instr_type_double;
        }
        formal->id = yyvsp[0].string;
        yyval.cformal = formal;
      ;}
    break;

  case 26:
#line 355 "instrument.y"
    {
        struct comp_iformal *formal;
        palloc(formal);
        formal->id = str_dup(yyvsp[0].string);
        formal->isoptional = 0; /* No default value */
        formal->type = instr_type_double;
        yyval.cformal = formal;
      ;}
    break;

  case 27:
#line 364 "instrument.y"
    {
        struct comp_iformal *formal;
        palloc(formal);
        formal->id = yyvsp[-2].string;
        formal->isoptional = 1; /* Default value available */
        formal->default_value = yyvsp[0].exp;
        formal->type = instr_type_double;
        yyval.cformal = formal;
      ;}
    break;

  case 28:
#line 374 "instrument.y"
    {
        struct comp_iformal *formal;
        palloc(formal);
        if(!strcmp(yyvsp[-3].string, "double")) {
          formal->type = instr_type_double;
        } else if(!strcmp(yyvsp[-3].string, "int")) {
          formal->type = instr_type_int;
        } else if(!strcmp(yyvsp[-3].string, "string")) {
          formal->type = instr_type_string;
        } else {
          print_error("Illegal type %s for component "
          "parameter %s at line %s:%d.\n", yyvsp[-3].string, yyvsp[-2].string, instr_current_filename, instr_current_line);
          formal->type = instr_type_double;
        }
        formal->id = yyvsp[-2].string;
        formal->isoptional = 1; /* Default value available */
        formal->default_value = yyvsp[0].exp;
        yyval.cformal = formal;
      ;}
    break;

  case 29:
#line 394 "instrument.y"
    {
        struct comp_iformal *formal;
        palloc(formal);
        formal->id = yyvsp[-2].string;
        formal->isoptional = 1; /* Default value available */
        formal->default_value = yyvsp[0].exp;
        if(!strcmp(yyvsp[-4].string, "char")) {
          formal->type = instr_type_string;
        } else {
          print_error("Illegal type %s* for component "
          "parameter %s at line %s:%d.\n", yyvsp[-4].string, yyvsp[-2].string, instr_current_filename, instr_current_line);
          formal->type = instr_type_double;
        }
        yyval.cformal = formal;
      ;}
    break;

  case 30:
#line 412 "instrument.y"
    { instrument_definition->formals = yyvsp[0].iformals; instrument_definition->name = yyvsp[-1].string; ;}
    break;

  case 31:
#line 414 "instrument.y"
    {
        instrument_definition->decls = yyvsp[-6].ccode;
        instrument_definition->inits = yyvsp[-5].ccode;
        instrument_definition->nxdinfo = yyvsp[-4].nxdinfo;
        instrument_definition->saves  = yyvsp[-2].ccode;
        instrument_definition->finals = yyvsp[-1].ccode;
        instrument_definition->compmap = comp_instances;
        instrument_definition->groupmap = group_instances;  /* ADD: E. Farhi Sep 25th, 2001 */
        instrument_definition->complist = comp_instances_list;
        instrument_definition->grouplist = group_instances_list;  /* ADD: E. Farhi Sep 25th, 2001 */

        /* Check instrument parameters for uniqueness */
        check_instrument_formals(instrument_definition->formals,
               instrument_definition->name);
        if (verbose) fprintf(stderr, "Creating instrument %s (with %i component instances)\n", instrument_definition->name, comp_current_index);
      ;}
    break;

  case 32:
#line 435 "instrument.y"
    {
        yyval.iformals = yyvsp[-1].iformals;
      ;}
    break;

  case 33:
#line 441 "instrument.y"
    {
        yyval.iformals = list_create();
      ;}
    break;

  case 34:
#line 445 "instrument.y"
    {
        yyval.iformals = yyvsp[0].iformals;
      ;}
    break;

  case 35:
#line 451 "instrument.y"
    {
        yyval.iformals = list_create();
        list_add(yyval.iformals, yyvsp[0].iformal);
      ;}
    break;

  case 36:
#line 456 "instrument.y"
    {
        list_add(yyvsp[-2].iformals, yyvsp[0].iformal);
        yyval.iformals = yyvsp[-2].iformals;
      ;}
    break;

  case 37:
#line 463 "instrument.y"
    {
        struct instr_formal *formal;
        palloc(formal);
        if(!strcmp(yyvsp[-1].string, "double")) {
          formal->type = instr_type_double;
        } else if(!strcmp(yyvsp[-1].string, "int")) {
          formal->type = instr_type_int;
        } else if(!strcmp(yyvsp[-1].string, "string")) {
          formal->type = instr_type_string;
        } else {
          print_error("Illegal type %s for instrument "
          "parameter %s at line %s:%d.\n", yyvsp[-1].string, yyvsp[0].string, instr_current_filename, instr_current_line);
          formal->type = instr_type_double;
        }
        formal->id = yyvsp[0].string;
        yyval.iformal = formal;
      ;}
    break;

  case 38:
#line 481 "instrument.y"
    {
        struct instr_formal *formal;
        palloc(formal);
        if(!strcmp(yyvsp[-2].string, "char")) {
          formal->type = instr_type_string;
        } else {
          print_error("Illegal type $s* for instrument "
          "parameter %s at line %s:%d.\n", yyvsp[-2].string, yyvsp[0].string, instr_current_filename, instr_current_line);
          formal->type = instr_type_double;
        }
        formal->id = yyvsp[0].string;
        yyval.iformal = formal;
      ;}
    break;

  case 39:
#line 495 "instrument.y"
    {
        struct instr_formal *formal;
        palloc(formal);
        formal->type = instr_type_double;
        formal->id = yyvsp[0].string;
        formal->isoptional = 0; /* No default value */
        yyval.iformal = formal;
      ;}
    break;

  case 40:
#line 504 "instrument.y"
    {
        struct instr_formal *formal;
        palloc(formal);
        formal->id = yyvsp[-2].string;
        formal->isoptional = 1; /* Default value available */
        formal->default_value = yyvsp[0].exp;
        formal->type = instr_type_double;
        yyval.iformal = formal;
      ;}
    break;

  case 41:
#line 514 "instrument.y"
    {
        struct instr_formal *formal;
        palloc(formal);
        if(!strcmp(yyvsp[-3].string, "double")) {
          formal->type = instr_type_double;
        } else if(!strcmp(yyvsp[-3].string, "int")) {
          formal->type = instr_type_int;
        } else if(!strcmp(yyvsp[-3].string, "string")) {
          formal->type = instr_type_string;
        } else {
          print_error("Illegal type %s for instrument "
          "parameter %s at line %s:%d.\n", yyvsp[-3].string, yyvsp[-2].string, instr_current_filename, instr_current_line);
          formal->type = instr_type_double;
        }
        formal->id = yyvsp[-2].string;
        formal->isoptional = 1; /* Default value available */
        formal->default_value = yyvsp[0].exp;
        yyval.iformal = formal;
      ;}
    break;

  case 42:
#line 534 "instrument.y"
    {
        struct instr_formal *formal;
        palloc(formal);
        formal->id = yyvsp[-2].string;
        formal->isoptional = 1; /* Default value available */
        formal->default_value = yyvsp[0].exp;
        if(!strcmp(yyvsp[-4].string, "char")) {
          formal->type = instr_type_string;
        } else {
          print_error("Illegal type %s* for instrument "
          "parameter %s at line %s:%d.\n", yyvsp[-4].string, yyvsp[-2].string, instr_current_filename, instr_current_line);
          formal->type = instr_type_double;
        }
        yyval.iformal = formal;
      ;}
    break;

  case 43:
#line 553 "instrument.y"
    {
        struct NXDinfo *nxdinfo;
        palloc(nxdinfo);
        nxdinfo->nxdfile = NULL;
        nxdinfo->any = 0;
        yyval.nxdinfo = nxdinfo;
      ;}
    break;

  case 44:
#line 561 "instrument.y"
    { /* use default NeXus dictionary file */
        struct NXDinfo *nxdinfo = yyvsp[-3].nxdinfo;
        if(nxdinfo->nxdfile)
        {
          print_error("Multiple NeXus DICTFILE declarations found (%s).\n"
          "At most one NeXus DICTFILE declarations may "
          "be used in an instrument", nxdinfo->nxdfile);
        }
        else
        {
          nxdinfo->nxdfile     = yyvsp[-1].string;
          nxdinfo->hdfversion = atof(yyvsp[0].number);
        }
        nxdinfo->any = 1; /* Now need NeXus support in runtime */
        yyval.nxdinfo = nxdinfo;
      ;}
    break;

  case 45:
#line 579 "instrument.y"
    {
        yyval.string = str_cat(instrument_definition->name, ".dic", NULL);
      ;}
    break;

  case 46:
#line 583 "instrument.y"
    {
        yyval.string = yyvsp[0].string;
      ;}
    break;

  case 47:
#line 588 "instrument.y"
    {
        yyval.number = "5";
      ;}
    break;

  case 48:
#line 592 "instrument.y"
    {
        yyval.number = yyvsp[0].number;
      ;}
    break;

  case 49:
#line 599 "instrument.y"
    {
        yyval.ccode = codeblock_new();
      ;}
    break;

  case 50:
#line 603 "instrument.y"
    {
        yyval.ccode = yyvsp[0].ccode;
      ;}
    break;

  case 51:
#line 607 "instrument.y"
    {
        struct comp_def *def;
        def = read_component(yyvsp[0].string);
        yyval.ccode = def->decl_code;
      ;}
    break;

  case 52:
#line 613 "instrument.y"
    {
        struct comp_def   *def;
        struct code_block *cb;
        cb = codeblock_new();
        def = read_component(yyvsp[-2].string);
        cb->filename        = def->decl_code->filename;
        cb->quoted_filename = def->decl_code->quoted_filename;
        cb->linenum         = def->decl_code->linenum;
        list_cat(cb->lines, def->decl_code->lines);
        list_cat(cb->lines, yyvsp[0].ccode->lines);
        yyval.ccode = cb;
      ;}
    break;

  case 53:
#line 628 "instrument.y"
    {
        yyval.ccode = codeblock_new();
      ;}
    break;

  case 54:
#line 632 "instrument.y"
    {
        struct comp_def *def;
        def = read_component(yyvsp[0].string);
        yyval.ccode = def->init_code;
      ;}
    break;

  case 55:
#line 638 "instrument.y"
    {
        struct comp_def   *def;
        struct code_block *cb;
        cb = codeblock_new();
        def = read_component(yyvsp[-2].string);
        cb->filename        = def->init_code->filename;
        cb->quoted_filename = def->init_code->quoted_filename;
        cb->linenum         = def->init_code->linenum;
        list_cat(cb->lines, def->init_code->lines);
        list_cat(cb->lines, yyvsp[0].ccode->lines);
        yyval.ccode = cb;
      ;}
    break;

  case 56:
#line 651 "instrument.y"
    {
        yyval.ccode = yyvsp[0].ccode;
      ;}
    break;

  case 57:
#line 658 "instrument.y"
    {
        yyval.ccode = codeblock_new();
      ;}
    break;

  case 58:
#line 662 "instrument.y"
    {
        yyval.ccode = yyvsp[0].ccode;
      ;}
    break;

  case 59:
#line 666 "instrument.y"
    {
        struct comp_def *def;
        def = read_component(yyvsp[0].string);
        yyval.ccode = def->share_code;
      ;}
    break;

  case 60:
#line 672 "instrument.y"
    {
        struct comp_def *def;
        struct code_block *cb;
        cb = codeblock_new();
        def = read_component(yyvsp[-2].string);
        cb->filename        = def->share_code->filename;
        cb->quoted_filename = def->share_code->quoted_filename;
        cb->linenum         = def->share_code->linenum;
        list_cat(cb->lines, def->share_code->lines);
        list_cat(cb->lines, yyvsp[0].ccode->lines);
        yyval.ccode = cb;
      ;}
    break;

  case 61:
#line 689 "instrument.y"
    {
        yyval.ccode = codeblock_new();
      ;}
    break;

  case 62:
#line 693 "instrument.y"
    {
        yyval.ccode = yyvsp[0].ccode;
      ;}
    break;

  case 63:
#line 697 "instrument.y"
    {
        struct comp_def *def;
        def = read_component(yyvsp[0].string);
        yyval.ccode = def->trace_code;
      ;}
    break;

  case 64:
#line 703 "instrument.y"
    {
        struct comp_def *def;
        struct code_block *cb;
        cb = codeblock_new();
        def = read_component(yyvsp[-2].string);
        cb->filename        = def->trace_code->filename;
        cb->quoted_filename = def->trace_code->quoted_filename;
        cb->linenum         = def->trace_code->linenum;
        list_cat(cb->lines, def->trace_code->lines);
        list_cat(cb->lines, yyvsp[0].ccode->lines);
        yyval.ccode = cb;
      ;}
    break;

  case 65:
#line 718 "instrument.y"
    {
        yyval.ccode = codeblock_new();
      ;}
    break;

  case 66:
#line 722 "instrument.y"
    {
        yyval.ccode = yyvsp[0].ccode;
      ;}
    break;

  case 67:
#line 726 "instrument.y"
    {
        struct comp_def *def;
        def = read_component(yyvsp[0].string);
        yyval.ccode = def->save_code;
      ;}
    break;

  case 68:
#line 732 "instrument.y"
    {
        struct comp_def *def;
        struct code_block *cb;
        cb = codeblock_new();
        def = read_component(yyvsp[-2].string);
        cb->filename        = def->save_code->filename;
        cb->quoted_filename = def->save_code->quoted_filename;
        cb->linenum         = def->save_code->linenum;
        list_cat(cb->lines, def->save_code->lines);
        list_cat(cb->lines, yyvsp[0].ccode->lines);
        yyval.ccode = cb;
      ;}
    break;

  case 69:
#line 747 "instrument.y"
    {
        yyval.ccode = codeblock_new();
      ;}
    break;

  case 70:
#line 751 "instrument.y"
    {
        yyval.ccode = yyvsp[0].ccode;
      ;}
    break;

  case 71:
#line 755 "instrument.y"
    {
        struct comp_def *def;
        def = read_component(yyvsp[0].string);
        yyval.ccode = def->finally_code;
      ;}
    break;

  case 72:
#line 761 "instrument.y"
    {
        struct comp_def *def;
        struct code_block *cb;
        cb = codeblock_new();
        def = read_component(yyvsp[-2].string);
        cb->filename        = def->finally_code->filename;
        cb->quoted_filename = def->finally_code->quoted_filename;
        cb->linenum         = def->finally_code->linenum;
        list_cat(cb->lines, def->finally_code->lines);
        list_cat(cb->lines, yyvsp[0].ccode->lines);
        yyval.ccode = cb;
      ;}
    break;

  case 73:
#line 776 "instrument.y"
    {
        yyval.ccode = codeblock_new();
      ;}
    break;

  case 74:
#line 780 "instrument.y"
    {
        yyval.ccode = yyvsp[0].ccode;
      ;}
    break;

  case 75:
#line 784 "instrument.y"
    {
        struct comp_def *def;
        def = read_component(yyvsp[0].string);
        yyval.ccode = def->mcdisplay_code;
      ;}
    break;

  case 76:
#line 790 "instrument.y"
    {
        struct comp_def *def;
        struct code_block *cb;
        cb = codeblock_new();
        def = read_component(yyvsp[-2].string);
        cb->filename        = def->mcdisplay_code->filename;
        cb->quoted_filename = def->mcdisplay_code->quoted_filename;
        cb->linenum         = def->mcdisplay_code->linenum;
        list_cat(cb->lines, def->mcdisplay_code->lines);
        list_cat(cb->lines, yyvsp[0].ccode->lines);
        yyval.ccode = cb;
      ;}
    break;

  case 78:
#line 807 "instrument.y"
    {
        comp_instances      = symtab_create();
        comp_instances_list = list_create();
        group_instances     = symtab_create();
        group_instances_list= list_create();
      ;}
    break;

  case 79:
#line 814 "instrument.y"
    {
        /* Check that the component instance name has not
                       been used before. */
        if(symtab_lookup(comp_instances, yyvsp[0].instance->name))
        {
          print_error("Multiple use of component instance name "
          "'%s' at line %s:%d.\n", yyvsp[0].instance->name, instr_current_filename, instr_current_line);
          /* Since this is an error condition, we do not
             worry about freeing the memory allocated for
       the component instance. */
        }
        else
        {
          symtab_add(comp_instances, yyvsp[0].instance->name, yyvsp[0].instance);
          list_add(comp_instances_list, yyvsp[0].instance);
          if(yyvsp[0].instance->def)
          {
            /* Check if the component handles polarisation. */
            if(yyvsp[0].instance->def->polarisation_par)
            {
              instrument_definition->polarised = 1;
            }
          }
        }
      ;}
    break;

  case 80:
#line 842 "instrument.y"
    {
        char str_index[10];
        sprintf(str_index, "_%i", comp_current_index+1);
        yyval.string = str_cat(yyvsp[-1].string, str_index, NULL);
      ;}
    break;

  case 81:
#line 848 "instrument.y"
    {
        yyval.string = yyvsp[0].string;
      ;}
    break;

  case 82:
#line 854 "instrument.y"
    {
        struct comp_inst *comp_src;
        struct comp_inst *comp;
        comp_src = yyvsp[-2].instance;
        palloc(comp);
        comp->type   = comp_src->type;
        comp->def    = comp_src->def;
        comp->extend = comp_src->extend;
        comp->group  = comp_src->group;
        comp->jump   = comp_src->jump;
        comp->when   = comp_src->when;
        /* now catenate src and actual parameters */
        comp->actuals= symtab_create();
        symtab_cat(comp->actuals, yyvsp[0].actuals);
        symtab_cat(comp->actuals, comp_src->actuals);
        comp_formals_actuals(comp, comp->actuals);
        yyval.instance = comp;
      ;}
    break;

  case 83:
#line 873 "instrument.y"
    {
        struct comp_inst *comp_src;
        struct comp_inst *comp;
        comp_src = yyvsp[-1].instance;
        palloc(comp);
        comp->type   = comp_src->type;
        comp->defpar = comp_src->defpar;
        comp->setpar = comp_src->setpar;
        comp->def    = comp_src->def;
        comp->extend = comp_src->extend;
        comp->group  = comp_src->group;
        comp->jump   = comp_src->jump;
        comp->when   = comp_src->when;
        comp->actuals= comp_src->actuals;
        yyval.instance = comp;
      ;}
    break;

  case 84:
#line 890 "instrument.y"
    {
        struct comp_def *def;
        struct comp_inst *comp;
        def = read_component(yyvsp[-1].string);
        if (def != NULL) def->comp_inst_number--;
        palloc(comp);
        comp->type         = yyvsp[-1].string;
        comp->def          = def;
        comp->extend = codeblock_new();
        comp->group  = NULL;
        comp->jump   = list_create();
        comp->when   = NULL;
        comp->actuals= yyvsp[0].actuals;
        if(def != NULL)
        {
          /* Check actual parameters against definition and
                         setting parameters. */
          comp_formals_actuals(comp, comp->actuals);
        }
        yyval.instance = comp;
      ;}
    break;

  case 85:
#line 914 "instrument.y"
    {

        struct comp_inst *comp;

        comp = yyvsp[-6].instance;
        if (comp->def != NULL) comp->def->comp_inst_number--;

        comp->name = yyvsp[-8].string;

        if (yyvsp[-5].exp) comp->when  = yyvsp[-5].exp;

        palloc(comp->pos);
        comp->pos->place = yyvsp[-4].place.place;
        comp->pos->place_rel = yyvsp[-4].place.place_rel;
        comp->pos->orientation = yyvsp[-3].ori.orientation;
        comp->pos->orientation_rel =
            yyvsp[-3].ori.isdefault ? yyvsp[-4].place.place_rel : yyvsp[-3].ori.orientation_rel;

        if (yyvsp[-2].groupinst)            comp->group = yyvsp[-2].groupinst;   /* component is part of an exclusive group */
        if (yyvsp[-1].ccode->linenum)   comp->extend= yyvsp[-1].ccode;  /* EXTEND block*/
        if (list_len(yyvsp[0].jumps)) comp->jump = yyvsp[0].jumps;
        comp->index = ++comp_current_index;     /* index of comp instance */

        debugn((DEBUG_HIGH, "Component[%i]: %s = %s().\n", comp_current_index, yyvsp[-8].string, yyvsp[-6].instance->type));
        previous_comp = comp; /* this comp will be 'previous' for the next */
        yyval.instance = comp;

      ;}
    break;

  case 86:
#line 945 "instrument.y"
    {
        yyval.formals = yyvsp[-1].formals;
      ;}
    break;

  case 87:
#line 952 "instrument.y"
    {
        yyval.formals = list_create();
      ;}
    break;

  case 88:
#line 956 "instrument.y"
    {
        yyval.formals = yyvsp[0].formals;
      ;}
    break;

  case 89:
#line 962 "instrument.y"
    {
        yyval.formals = list_create();
        list_add(yyval.formals, yyvsp[0].string);
      ;}
    break;

  case 90:
#line 967 "instrument.y"
    {
        list_add(yyvsp[-2].formals, yyvsp[0].string);
        yyval.formals = yyvsp[-2].formals;
      ;}
    break;

  case 91:
#line 974 "instrument.y"
    {
        yyval.actuals = yyvsp[-1].actuals;
      ;}
    break;

  case 92:
#line 980 "instrument.y"
    {
        yyval.actuals = symtab_create();
      ;}
    break;

  case 93:
#line 984 "instrument.y"
    {
        yyval.actuals = yyvsp[0].actuals;
      ;}
    break;

  case 94:
#line 990 "instrument.y"
    {
        yyval.actuals = symtab_create();
        symtab_add(yyval.actuals, yyvsp[-2].string, yyvsp[0].exp);
        str_free(yyvsp[-2].string);
      ;}
    break;

  case 95:
#line 996 "instrument.y"
    {
        symtab_add(yyvsp[-4].actuals, yyvsp[-2].string, yyvsp[0].exp);
        str_free(yyvsp[-2].string);
        yyval.actuals = yyvsp[-4].actuals;
      ;}
    break;

  case 96:
#line 1004 "instrument.y"
    {
      yyval.exp = NULL;
    ;}
    break;

  case 97:
#line 1008 "instrument.y"
    {
      yyval.exp = yyvsp[0].exp;
    ;}
    break;

  case 98:
#line 1014 "instrument.y"
    {
        yyval.place.place = yyvsp[-1].coords;
        yyval.place.place_rel = yyvsp[0].instance;
      ;}
    break;

  case 99:
#line 1021 "instrument.y"
    {
        yyval.ori.orientation = coords_exp_origo(); /* Default to (0,0,0). */
        yyval.ori.isdefault = 1; /* No ROTATED modifier was present */
      ;}
    break;

  case 100:
#line 1026 "instrument.y"
    {
        yyval.ori.orientation = yyvsp[-1].coords;
        yyval.ori.orientation_rel = yyvsp[0].instance;
        yyval.ori.isdefault = 0;
      ;}
    break;

  case 101:
#line 1035 "instrument.y"
    {
        yyval.instance = NULL;
      ;}
    break;

  case 102:
#line 1039 "instrument.y"
    {
        yyval.instance = NULL; /* tolerate this reference error */
      ;}
    break;

  case 103:
#line 1043 "instrument.y"
    {
        yyval.instance = yyvsp[0].instance;
      ;}
    break;

  case 104:
#line 1050 "instrument.y"
    {
        yyval.groupinst = NULL;
      ;}
    break;

  case 105:
#line 1054 "instrument.y"
    {
        yyval.groupinst = yyvsp[0].groupinst;
      ;}
    break;

  case 106:
#line 1060 "instrument.y"
    {
        struct group_inst *group;
        struct Symtab_entry *ent;

        ent = symtab_lookup(group_instances, yyvsp[0].string);
        if(ent == NULL)
        {
          palloc(group);    /* create new group instance */
          group->name = yyvsp[0].string;
          group->index= 0;
          symtab_add(group_instances, yyvsp[0].string, group);
          list_add(group_instances_list, group);
        }
        else
          group = ent->val;
        yyval.groupinst = group;
      ;}
    break;

  case 107:
#line 1080 "instrument.y"
    {
        if (previous_comp) {
          yyval.instance = previous_comp;
        } else {
          print_warn(NULL, "Found invalid PREVIOUS reference at line %s:%d. Using ABSOLUTE.\n", instr_current_filename, instr_current_line);
          yyval.instance = NULL;
        }
      ;}
    break;

  case 108:
#line 1089 "instrument.y"
    {
        /* get the $3 previous item in comp_instances */
        struct Symtab_entry *entry;
        int index;
        index = atoi(yyvsp[-1].number);
        entry = symtab_previous(comp_instances, index);
        if (!index || !entry) { /* invalid index reference */
          print_warn(NULL, "Found invalid PREVIOUS(%i) reference at line %s:%d. Using ABSOLUTE.\n", index, instr_current_filename, instr_current_line);
          yyval.instance = NULL;
        } else {
          yyval.instance = entry->val;
        }
      ;}
    break;

  case 109:
#line 1103 "instrument.y"
    {
        struct comp_inst *comp;
        struct Symtab_entry *ent;

        ent = symtab_lookup(comp_instances, yyvsp[0].string);
        comp = NULL;
        if(ent == NULL)
          print_error("Reference to undefined component %s at line %s:%d.\n",
          yyvsp[0].string, instr_current_filename, instr_current_line);
        else
          comp = ent->val;
        str_free(yyvsp[0].string);
        yyval.instance = comp;
      ;}
    break;

  case 110:
#line 1120 "instrument.y"
    {
        yyval.coords.x = yyvsp[-5].exp;
        yyval.coords.y = yyvsp[-3].exp;
        yyval.coords.z = yyvsp[-1].exp;
      ;}
    break;

  case 111:
#line 1129 "instrument.y"
    {
        yyval.ccode = codeblock_new();
      ;}
    break;

  case 112:
#line 1133 "instrument.y"
    {
        yyval.ccode = yyvsp[0].ccode;
      ;}
    break;

  case 113:
#line 1139 "instrument.y"
    {
      yyval.jumps = list_create();
    ;}
    break;

  case 114:
#line 1143 "instrument.y"
    {
      yyval.jumps = yyvsp[0].jumps;
    ;}
    break;

  case 115:
#line 1149 "instrument.y"
    {
      yyval.jumps = list_create();
      list_add(yyval.jumps, yyvsp[0].jump);
    ;}
    break;

  case 116:
#line 1154 "instrument.y"
    {
      list_add(yyvsp[-1].jumps, yyvsp[0].jump);
      yyval.jumps = yyvsp[-1].jumps;
    ;}
    break;

  case 117:
#line 1161 "instrument.y"
    {
      struct jump_struct *jump;
      palloc(jump);
      jump->target      =yyvsp[-1].jumpname.name;
      jump->target_index=yyvsp[-1].jumpname.index;
      jump->condition  = yyvsp[0].jumpcondition.condition;
      jump->iterate    = yyvsp[0].jumpcondition.iterate;
      yyval.jump=jump;
    ;}
    break;

  case 118:
#line 1173 "instrument.y"
    {
      yyval.jumpcondition.condition = yyvsp[0].exp;
      yyval.jumpcondition.iterate   = 0;
    ;}
    break;

  case 119:
#line 1178 "instrument.y"
    {
      yyval.jumpcondition.condition = yyvsp[0].exp;
      yyval.jumpcondition.iterate   = 1;
    ;}
    break;

  case 120:
#line 1185 "instrument.y"
    {
      yyval.jumpname.name  = NULL;
      yyval.jumpname.index = -1;
    ;}
    break;

  case 121:
#line 1190 "instrument.y"
    {
      yyval.jumpname.name  = NULL;
      yyval.jumpname.index = -atoi(yyvsp[-1].number);
    ;}
    break;

  case 122:
#line 1195 "instrument.y"
    {
      yyval.jumpname.name  = NULL;
      yyval.jumpname.index = 0;
    ;}
    break;

  case 123:
#line 1200 "instrument.y"
    {
      yyval.jumpname.name  = NULL;
      yyval.jumpname.index = +1;
    ;}
    break;

  case 124:
#line 1205 "instrument.y"
    {
      yyval.jumpname.name  = NULL;
      yyval.jumpname.index = +atoi(yyvsp[-1].number);    ;}
    break;

  case 125:
#line 1209 "instrument.y"
    {
      yyval.jumpname.name  = str_dup(yyvsp[0].string);
      yyval.jumpname.index = 0;
    ;}
    break;

  case 126:
#line 1217 "instrument.y"
    { yyval.linenum = instr_current_line; ;}
    break;

  case 127:
#line 1218 "instrument.y"
    {
        CExp e = yyvsp[0].exp;
        exp_setlineno(e, yyvsp[-1].linenum );
        yyval.exp = e;
      ;}
    break;

  case 128:
#line 1223 "instrument.y"
    { yyval.linenum = instr_current_line; ;}
    break;

  case 129:
#line 1224 "instrument.y"
    {
        CExp e;
        /* Note: "EXTERN" is now obsolete and redundant. */
        e = exp_extern_id(yyvsp[0].string);
        exp_setlineno(e, yyvsp[-1].linenum );
        str_free(yyvsp[0].string);
        yyval.exp = e;
      ;}
    break;

  case 130:
#line 1235 "instrument.y"
    {
        yyval.exp = yyvsp[0].exp;
      ;}
    break;

  case 131:
#line 1239 "instrument.y"
    {
        yyval.exp = exp_compound(2, yyvsp[-1].exp, yyvsp[0].exp);
        exp_free(yyvsp[0].exp);
        exp_free(yyvsp[-1].exp);
      ;}
    break;

  case 132:
#line 1249 "instrument.y"
    {
        List_handle liter;
        struct instr_formal *formal;
        /* Check if this is an instrument parameter or not. */
        /* ToDo: This will be inefficient if the number of
                       instrument parameters is really huge. */
        liter = list_iterate(instrument_definition->formals);
        while(formal = list_next(liter))
        {
          if(!strcmp(yyvsp[0].string, formal->id))
          {
            /* It was an instrument parameter */
            yyval.exp = exp_id(yyvsp[0].string);
            goto found;
          }
        }
        list_iterate_end(liter);
        /* It was an external id. */
        yyval.exp = exp_extern_id(yyvsp[0].string);
      found:
        str_free(yyvsp[0].string);
      ;}
    break;

  case 133:
#line 1272 "instrument.y"
    {
        yyval.exp = exp_number(yyvsp[0].number);
        str_free(yyvsp[0].number);
      ;}
    break;

  case 134:
#line 1277 "instrument.y"
    {
        yyval.exp = exp_string(yyvsp[0].string);
        str_free(yyvsp[0].string);
      ;}
    break;

  case 135:
#line 1282 "instrument.y"
    {
        yyval.exp = exp_ctoken(yyvsp[0].string);
        str_free(yyvsp[0].string);
      ;}
    break;

  case 136:
#line 1287 "instrument.y"
    {
        yyval.exp = exp_ctoken("=");
      ;}
    break;

  case 137:
#line 1291 "instrument.y"
    {
        yyval.exp = exp_ctoken("*");
      ;}
    break;

  case 138:
#line 1295 "instrument.y"
    {
        CExp p1 = exp_ctoken("(");
        CExp p2 = exp_ctoken(")");
        yyval.exp = exp_compound(3, p1, yyvsp[-1].exp, p2);
        exp_free(p2);
        exp_free(p1);
        exp_free(yyvsp[-1].exp);
      ;}
    break;

  case 139:
#line 1304 "instrument.y"
    {
        CExp p1 = exp_ctoken("(");
        CExp p2 = exp_ctoken(")");
        yyval.exp = exp_compound(2, p1, p2);
        exp_free(p2);
        exp_free(p1);
      ;}
    break;

  case 140:
#line 1312 "instrument.y"
    {
        CExp p1 = exp_ctoken("[");
        CExp p2 = exp_ctoken("]");
        yyval.exp = exp_compound(3, p1, yyvsp[-1].exp, p2);
        exp_free(p2);
        exp_free(p1);
        exp_free(yyvsp[-1].exp);
      ;}
    break;

  case 141:
#line 1321 "instrument.y"
    {
        CExp p1 = exp_ctoken("[");
        CExp p2 = exp_ctoken("]");
        yyval.exp = exp_compound(2, p1, p2);
        exp_free(p2);
        exp_free(p1);
      ;}
    break;

  case 142:
#line 1329 "instrument.y"
    {
        CExp p1 = exp_ctoken("{");
        CExp p2 = exp_ctoken("}");
        yyval.exp = exp_compound(3, p1, yyvsp[-1].exp, p2);
        exp_free(p2);
        exp_free(p1);
        exp_free(yyvsp[-1].exp);
      ;}
    break;

  case 143:
#line 1338 "instrument.y"
    {
        CExp p1 = exp_ctoken("{");
        CExp p2 = exp_ctoken("}");
        yyval.exp = exp_compound(2, p1, p2);
        exp_free(p2);
        exp_free(p1);
      ;}
    break;

  case 144:
#line 1349 "instrument.y"
    {
        yyval.exp = yyvsp[0].exp;
      ;}
    break;

  case 145:
#line 1353 "instrument.y"
    {
        yyval.exp = exp_compound(2, yyvsp[-1].exp, yyvsp[0].exp);
        exp_free(yyvsp[0].exp);
        exp_free(yyvsp[-1].exp);
      ;}
    break;

  case 146:
#line 1361 "instrument.y"
    {
        yyval.exp = yyvsp[0].exp;
      ;}
    break;

  case 147:
#line 1365 "instrument.y"
    {
        yyval.exp = exp_ctoken(",");
      ;}
    break;

  case 148:
#line 1371 "instrument.y"
    {
        yyvsp[-1].ccode->filename = instr_current_filename;
        yyvsp[-1].ccode->quoted_filename = str_quote(instr_current_filename);
        yyvsp[-1].ccode->linenum = yyvsp[-2].linenum;
        yyval.ccode = yyvsp[-1].ccode;
      ;}
    break;

  case 149:
#line 1380 "instrument.y"
    {
        yyval.ccode = codeblock_new();
      ;}
    break;

  case 150:
#line 1385 "instrument.y"
    {
        list_add(yyvsp[-1].ccode->lines, yyvsp[0].string);
        yyval.ccode = yyvsp[-1].ccode;
      ;}
    break;


    }

/* Line 1010 of yacc.c.  */
#line 2927 "instrument.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1391 "instrument.y"


static Pool parser_pool = NULL; /* Pool of parser allocations. */

static int mc_yyparse(void)
{
  int ret;
  Pool oldpool;

  oldpool = parser_pool;
  parser_pool = pool_create();
  ret = yyparse();
  pool_free(parser_pool);
  parser_pool = oldpool;
  return ret;
}

/* Name of the file currently being parsed. */
char *instr_current_filename = NULL;
/* Number of the line currently being parsed. */
int instr_current_line = 0;
/* current instance index */
long comp_current_index=0;

/* Result from parsing instrument definition. */
struct instr_def *instrument_definition;

/* Map from names to component instances. */
Symtab comp_instances;

/* Will store component instance for PREVIOUS reference */
struct comp_inst *previous_comp=NULL;

/* ADD: E. Farhi Sep 24th, 2001 Map from names to component group instances. */
Symtab group_instances;

/* Map from names to embedded libraries */
Symtab lib_instances;

/* List of components, in the order they where declared in the instrument
   definition. */
List comp_instances_list;

/* List of component groups, in the order they where declared in the instrument
   definition. */
List group_instances_list;

/* Filename for outputting generated simulation program ('-' means stdin). */
static char *output_filename;

/* Verbose parsing/code generation */
char verbose;

/* Map of already-read components. */
Symtab read_components = NULL;

/* Print a summary of the command usage and exit with error. */
static void
print_usage(void)
{
  fprintf(stderr, "Usage:\n"
    "  mcstas [-o file] [-I dir1 ...] [-t] [-p] [-v] "
    "[--no-main] [--no-runtime] [--verbose] file\n");
  fprintf(stderr, "      -o FILE --output-file=FILE Place C output in file FILE.\n");
  fprintf(stderr, "      -I DIR  --search-dir=DIR   Append DIR to the component search list. \n");
  fprintf(stderr, "      -t      --trace            Enable 'trace' mode for instrument display.\n");
  fprintf(stderr, "      -v      --version          Prints McStas version.\n");
  fprintf(stderr, "      --no-main                  Do not create main(), for external embedding.\n");
  fprintf(stderr, "      --no-runtime               Do not embed run-time libraries.\n");
  fprintf(stderr, "      --verbose                  Display compilation process steps.\n");
  fprintf(stderr, "  The file will be processed and translated into a C code program.\n");
  fprintf(stderr, "  The default component search list is usually defined by the 'MCSTAS'\n");
  fprintf(stderr, "  environment variable. Use 'mcrun' to both run mcstas and the C compiler.\n");
  fprintf(stderr, "  Use 'mcgui' to run the McStas GUI.\n");
  fprintf(stderr, "  If run-time libraries are not embedded, you will have to pre-compile\n");
  fprintf(stderr, "  them (.c -> .o) before assembling the program.\n");
  fprintf(stderr, "SEE ALSO: mcrun, mcplot, mcdisplay, mcresplot, mcstas2vitess, mcgui\n");
  fprintf(stderr, "DOC:      Please visit " PACKAGE_BUGREPORT "\n");
  exit(1);
}

/* Print McStas version and copyright. */
static void
print_version(void)
{ /* MOD: E. Farhi Sep 20th, 2001 version number */
  printf("McStas version " MCSTAS_VERSION "\n"
    "Copyright (C) Risoe National Laboratory, 1997-2006\n"
    "Additions (C) Institut Laue Langevin, 2003-2006\n"
    "All rights reserved\n");
  exit(0);
}

/* Construct default filename for simulation output from instrument file
   name. Strip any leading directory path and trailing .instr, and add .c to
   the end. */
static char *
make_output_filename(char *name)
{
  char *p;
  int l;

  /* Find basename */
  p = strrchr(name, '/');
  if(p == NULL)
    p = name;     /* No initial path. */
  else
    p++;      /* Point past last '/' character. */

  /* Check for trailing .instr suffix. */
  l = strlen(p);
  if(l > 6 && !strcmp(&p[l - 6], ".instr"))
  {
    char *tmp = str_dup(p);
    tmp[l - 6] = '\0';
    p = str_cat(tmp, ".c", NULL);
    str_free(tmp);
  }
  else
    p = str_cat(p, ".c", NULL);
  return p;
}


static void
set_output_filename(char *name)
{
  output_filename = str_dup(name);
}

/* Parse command line options. */
static void
parse_command_line(int argc, char *argv[])
{
  int i;

  output_filename = NULL;
  verbose = 0;
  instr_current_filename = NULL;
  instrument_definition->use_default_main = 1;
  instrument_definition->include_runtime = 1;
  instrument_definition->enable_trace = 0;
  instrument_definition->portable = 0;
  instrument_definition->polarised = 0;
  for(i = 1; i < argc; i++)
  {
    if(!strcmp("-o", argv[i]) && (i + 1) < argc)
      set_output_filename(argv[++i]);
    else if(!strncmp("-o", argv[i], 2))
      set_output_filename(&argv[i][2]);
    else if(!strcmp("--output-file", argv[i]) && (i + 1) < argc)
      set_output_filename(argv[++i]);
    else if(!strncmp("--output-file=", argv[i], 14))
      set_output_filename(&argv[i][14]);
    else if(!strcmp("-I", argv[i]) && (i + 1) < argc)
      add_search_dir(argv[++i]);
    else if(!strncmp("-I", argv[i], 2))
      add_search_dir(&argv[i][2]);
    else if(!strcmp("--search-dir", argv[i]) && (i + 1) < argc)
      add_search_dir(argv[++i]);
    else if(!strncmp("--search-dir=", argv[i], 13))
      add_search_dir(&argv[i][13]);
    else if(!strcmp("-t", argv[i]))
      instrument_definition->enable_trace = 1;
    else if(!strcmp("--trace", argv[i]))
      instrument_definition->enable_trace = 1;
    else if(!strcmp("-p", argv[i]))
      instrument_definition->portable = 1;
    else if(!strcmp("--portable", argv[i]))
      instrument_definition->portable = 1;
    else if(!strcmp("-v", argv[i]))
      print_version();
    else if(!strcmp("--version", argv[i]))
      print_version();
    else if(!strcmp("--verbose", argv[i]))
      verbose = 1;
    else if(!strcmp("--no-main", argv[i]))
      instrument_definition->use_default_main = 0;
    else if(!strcmp("--no-runtime", argv[i]))
      instrument_definition->include_runtime = 0;
    else if(argv[i][0] != '-')
    {
      if(instr_current_filename != NULL)
        print_usage();    /* Multiple instruments given. */
      instr_current_filename = str_dup(argv[i]);
    }
    else
      print_usage();
  }

  /* Instrument filename must be given. */
  if(instr_current_filename == NULL)
    print_usage();
  /* If no '-o' option was given for INSTR.instr, default to INSTR.c  */
  if(output_filename == NULL)
    output_filename = make_output_filename(instr_current_filename);
}


int
main(int argc, char *argv[])
{
  FILE *file;
  int err;

#ifdef MAC
  argc = ccommand(&argv);
#endif

  yydebug = 0;      /* If 1, then bison gives verbose parser debug info. */

  palloc(instrument_definition); /* Allocate instrument def. structure. */
  parse_command_line(argc, argv);
  if(!strcmp(instr_current_filename, "-"))
  {
    instrument_definition->source = str_dup("<stdin>");
    file = fdopen(0, "r");  /* Lone '-' designates stdin. */
  }
  else
  {
    instrument_definition->source = str_dup(instr_current_filename);
    file = fopen(instr_current_filename, "r");
  }
  if(file == NULL)
    fatal_error("Instrument definition file `%s' not found\n",
    instr_current_filename);
  instrument_definition->quoted_source =
    str_quote(instrument_definition->source);
  instr_current_line = 1;
  lex_new_file(file);
  read_components = symtab_create(); /* Create table of components. */
  lib_instances   = symtab_create(); /* Create table of libraries. */
  err = mc_yyparse();
  fclose(file);
  if(err != 0 || error_encountered != 0)
  {
    print_error("Errors encountered during parse.\n");
    exit(1);
  }
  else
  {

    cogen(output_filename, instrument_definition);
    if (verbose) fprintf(stderr, "Generating code     %s\n", output_filename);
    exit(0);
  }
}


int
yyerror(char *s)
{
  print_error("%s at line %d.\n", s, instr_current_line);
  return 0;
}


/*******************************************************************************
* Check that all formal parameters of a component definition are unique.
*******************************************************************************/
void
check_comp_formals(List deflist, List setlist, char *compname)
{
  Symtab formals;
  struct comp_iformal *formal;
  struct Symtab_entry *entry;
  List_handle liter;

  /* We check the uniqueness by adding all the formals to a symbol table with
     a dummy pointer value. Any formal parameter that already appears in the
     symbol table is an error. */
  formals = symtab_create();
  liter = list_iterate(deflist);
  while(formal = list_next(liter))
  {
    entry = symtab_lookup(formals, formal->id);
    if(entry != NULL)
      print_error("Definition parameter name %s is used multiple times "
      "in component %s\n", formal->id, compname);
    else
      symtab_add(formals, formal->id, NULL);
  }
  list_iterate_end(liter);
  liter = list_iterate(setlist);
  while(formal = list_next(liter))
  {
    entry = symtab_lookup(formals, formal->id);
    if(entry != NULL)
      print_error("Setting parameter name %s is used multiple times "
      "in component %s\n", formal->id, compname);
    else
      symtab_add(formals, formal->id, NULL);
  }
  list_iterate_end(liter);
  symtab_free(formals, NULL);
}


/*******************************************************************************
* Check that all formal parameters of an instrument definition are unique.
*******************************************************************************/
void
check_instrument_formals(List formallist, char *instrname)
{
  Symtab formals;
  struct instr_formal *formal;
  struct Symtab_entry *entry;
  List_handle liter;

  /* We check the uniqueness by adding all the formals to a symbol table with
     a dummy pointer value. Any formal parameter that already appears in the
     symbol table is an error. */
  formals = symtab_create();
  liter = list_iterate(formallist);
  while(formal = list_next(liter))
  {
    entry = symtab_lookup(formals, formal->id);
    if(entry != NULL)
      print_error("Instrument parameter name %s is used multiple times "
      "in instrument %s\n", formal->id, instrname);
    else
      symtab_add(formals, formal->id, NULL);
  }
  list_iterate_end(liter);
  symtab_free(formals, NULL);
}

/*******************************************************************************
* Check the actual parameters to a component against the formal parameters.
*******************************************************************************/
void
comp_formals_actuals(struct comp_inst *comp, Symtab actuals)
{
  List_handle liter;
  struct comp_iformal *formal;
  struct Symtab_entry *entry;
  Symtab defpar, setpar;
  Symtab_handle siter;

  /* We need to check
     1. That all actual parameters correspond to formal parameters.
     2. That all formal parameters are assigned actual parameters. */

  /* First check the formal parameters one by one. */
  defpar = symtab_create();
  setpar = symtab_create();
  liter = list_iterate(comp->def->def_par);
  while(formal = list_next(liter))
  {
    entry = symtab_lookup(actuals, formal->id);
    if(entry == NULL)
    {
      if(formal->isoptional)
      {
        /* Use default value for unassigned optional parameter */
        symtab_add(defpar, formal->id, formal->default_value);
      } else {
        print_error("Unassigned DEFINITION parameter %s for component %s at line %s:%d.\n",
              formal->id, comp->type,
              instr_current_filename, instr_current_line);
        symtab_add(defpar, formal->id, exp_number("0.0"));
      }
    } else {
      symtab_add(defpar, formal->id, entry->val);
      /* Ensure that the actual DEFINITION parameters are all values
         (identifiers, constant numbers, and constant strings). This is
         necessary to avoid duplication of computations or side effects in the
         expressions for the actual parameters, since DEFINITION parameters
         are assigned using #define's. */
      if(!exp_isvalue(entry->val))
      {
  print_warn(NULL, "Using DEFINITION parameter of component %s (potential syntax error) at line %s:%d\n"
    "  %s=%s\n",
    comp->type, instr_current_filename, instr_current_line,
    formal->id, exp_tostring(entry->val));
      }
    }
  }
  list_iterate_end(liter);
  liter = list_iterate(comp->def->set_par);
  while(formal = list_next(liter))
  {
    entry = symtab_lookup(actuals, formal->id);
    if(entry == NULL)
    {
      if(formal->isoptional)
      {
        /* Use default value for unassigned optional parameter */
        symtab_add(setpar, formal->id, formal->default_value);
      } else {
        print_error("Unassigned SETTING parameter %s for component %s at line %s:%d.\n",
              formal->id, comp->type,
              instr_current_filename, instr_current_line);
        symtab_add(setpar, formal->id, exp_number("0.0"));
      }
    } else {
      symtab_add(setpar, formal->id, entry->val);
    }
  }
  list_iterate_end(liter);

  /* Now check the actual parameters one by one. */
  siter = symtab_iterate(actuals);
  while(entry = symtab_next(siter))
  {
    if(symtab_lookup(defpar, entry->name) == NULL &&
       symtab_lookup(setpar, entry->name) == NULL)
    {
      Symtab_handle siter2;
      struct Symtab_entry *entry2;

      fprintf(stderr, "Unmatched actual parameter %s for component %s at line %s:%d.\n",
        entry->name, comp->type,
        instr_current_filename, instr_current_line);
      siter2 = symtab_iterate(defpar);
      fprintf(stderr,"  Definition parameters: ");
      while(entry2 = symtab_next(siter2))
        fprintf(stderr, "%s ", entry2->name);
      symtab_iterate_end(siter2);
      siter2 = symtab_iterate(setpar);
      fprintf(stderr,"\n  Setting parameters: ");
      while(entry2 = symtab_next(siter2))
        fprintf(stderr, "%s ", entry2->name);
      symtab_iterate_end(siter2);
      print_error("\n");
    }
  }
  symtab_iterate_end(siter);
  comp->defpar = defpar;
  comp->setpar = setpar;
}


/*******************************************************************************
* This is the main entry point for reading a component. When a component
* definition is needed, this function is called with the name of the
* component. A map of previously read components is maintained. If a
* component definition (struct comp)def) is found, it is returned. Otherwise
* an attempt is made to read the component definition from a file with the
* same name as the component with added file extension ".com".
* If for some reasons the component cannot be read, NULL is returned; else a
* pointer to a struct comp_def is returned. Since components definitions can
* be used multiple times, the returned structure is shared and should not be
* modified.
*******************************************************************************/
struct comp_def *
read_component(char *name)
{
  struct Symtab_entry *entry;

  /* Look for an existing definition for the component. */
  entry = symtab_lookup(read_components, name);
  if(entry != NULL)
  {
    return entry->val;    /* Return it if found. */
  }
  else
  {
    FILE *file;
    int err;

    /* Attempt to read definition from file components/<name>.com. */
    file = open_component_search(name);
    if(file == NULL)
    {
      print_error(
        "Cannot find file containing definition of component `%s'.\n", name);
      return NULL;
    }
    push_autoload(file);
    /* Note: the str_dup copy of the file name is stored in codeblocks, and
       must not be freed. */
    instr_current_filename = component_pathname;
    instr_current_line = 1;
    err = mc_yyparse();   /* Read definition from file. */
    if(err != 0)
      fatal_error("Errors encountered during autoload of component %s.\n",
        name);
    fclose(file);
    /* Now check if the file contained the required component definition. */
    entry = symtab_lookup(read_components, name);
    if(entry != NULL)
    {
      return entry->val;
    }
    else
    {
      print_error("Definition of component %s not found.\n", name);
      return NULL;
    }
  }
}

